<template>
  <v-app>
    <v-layout justify-center style="margin-top:100px;">
      <v-flex xs10 md10 style="padding:60px;">
        <v-card class="mx-auto" elevation="1" style="height:auto;">
          <v-container>
            <!-- ------------------------- การส่งรายการภาษี --------------------------- -->
            <center>
              <h3 style="font-family: Sarabun, sans-serif;">
                ขั้นตอน 2 : การส่งรายการภาษี
              </h3>
            </center>
            <br />
            <v-layout justify-center>
              <v-data-table
                :headers="headers"
                :items="data_ewht"
                class="elevation-1 table-style"
                hide-actions
              >
                <template v-slot:items="props">
                  <tr>
                    <td class="text-xs-left">
                      {{ props.item.order_id }}
                    </td>

                    <td class="text-xs-center">
                      <div
                        v-if="
                          props.item.process == 'In process' &&
                            props.item.status == null
                        "
                      >
                        <v-btn-toggle v-model="props.item.status">
                          <v-btn
                            @click="
                              callEwht(
                                props.item.payment_no,
                                'success',
                                props.item.rd_ref
                              )
                            "
                            class="btn-completed"
                            :value="'success'"
                            >Completed
                          </v-btn>
                          <v-btn
                            @click="
                              callEwht(
                                props.item.payment_no,
                                'fail',
                                props.item.rd_ref
                              )
                            "
                            class="btn-rejected"
                            :value="'fail'"
                            >Rejected
                          </v-btn>
                        </v-btn-toggle>
                      </div>

                      <div v-else>
                        <v-btn
                          v-if="props.item.status == 'success'"
                          class="btn-rejected"
                          disabled
                        >
                          Completed
                        </v-btn>
                        <v-btn
                          v-if="props.item.status == 'fail'"
                          class="btn-rejected"
                          disabled
                        >
                          Rejected
                        </v-btn>
                      </div>
                    </td>
                  </tr>
                </template>
              </v-data-table>
            </v-layout>
            <v-layout justify-center>
              <v-btn @click="submitEwhtCallback" class="btn-submit">
                Submit
              </v-btn>
            </v-layout>
          </v-container>
        </v-card>
      </v-flex>
    </v-layout>

    <v-footer>
      <span style="padding-left: 30px;font-family: Sarabun, sans-serif;"
        >© 2021 - ePayment Sandbox</span
      >
    </v-footer>
  </v-app>
</template>

<script>
import moment from "moment";
import Swal from "sweetalert2";

export default {
  data() {
    return {
      token: "",
      mobileView: false,
      headers: [
        { text: "หมายเลขรายการจ่ายเงิน", value: "order_id", sortable: false },
        {
          text: "สถานะ",
          value: "status_message",
          sortable: false,
          align: "center"
        }
      ],
      status_sandbox: this.$cookies.get("status_sandbox"),
      datetime: new Date(),
      data_ewht: [],
      data_payment: [],
      data_sandboxrd: [],
      rd_result: [],
      rdref: "",
      paymentno: []
    };
  },
  methods: {
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    async getEwhtCallback() {
      try {
        var { data } = await this.axios.post(
          `${process.env.VUE_APP_APIHOST}/sendbox/ewht`,
          {
            data: this.data_payment
          },
          {
            headers: { Authorization: this.token }
          }
        );
        if (data.status == "Success") {
          this.data_ewht = data.data;
          console.log("data_ewht", this.data_ewht);

          // let i = 0;
          // if (this.data_ewht.length > 0) {
          //   for (let index = 0; index < this.data_ewht.length; index++) {
          //     const element = this.data_ewht[index];

          //     if (element && element.status == "success") {
          //       i = i + 1;
          //     }
          //     if (i == this.data_ewht.length) {
          //       for (let index = 0; index < this.data_ewht.length; index++) {
          //         const _data = this.data_ewht[index];

          //         if (_data) {
          //           this.data_sandboxrd.push(_data.rd_ref);
          //         }
          //       }
          //       this.$cookies.set("status_sandbox", "rd_directcredit");
          //       this.$router.push({
          //         path: "/sandboxrd",
          //         query: { data: this.data_sandboxrd }
          //       });
          //     } else {
          //       this.$cookies.set("status_sandbox", "receiver_ewht");
          //     }
          //   }
          // }
        } else if (data.status == "no ewht") {
          Swal.fire({
            title: "ทดสอบสำเร็จแล้ว",
            text: "สามารถตรวจสอบได้ที่ หน้าประวัติการทำรายการ",
            icon: "success"
          }).then(result => {
            close();
          });
        } else {
          console.log(data);
        }
      } catch (error) {
        console.log(error.message);
      }
    },
    callEwht(_payment_no, _status, _rdref) {
      let _process = "";
      let _description = "";
      if (_status == "success") {
        _process = "validated";
        _description = "สำเร็จ";
      } else if (_status == "fail") {
        _process = "validated";
        _description = "ตรวจสอบเนื้อหาไม่ถูกต้อง";
      }

      let _data = {
        transaction_ref: _payment_no,
        process: _process,
        status: _status,
        description: _description,
        transaction_date: moment(this.datetime).format("YYYYMMDD"),
        transaction_time: moment(this.datetime).format("HHmmss")
      };
      this.rdref = _rdref;
      this.rd_result.push(_data);
    },
    async submitEwhtCallback() {
      let cksubmit = "";
      for (let index = 0; index < this.data_ewht.length; index++) {
        const element = this.data_ewht[index];

        if (
          element &&
          element.process == "In process" &&
          element.status == null
        ) {
          cksubmit = false;
          alert("กรุณาเลือกสถานะให้ครบ");
          break;
        }
      }

      if (cksubmit !== false) {
        try {
          var { data } = await this.axios.post(
            `${process.env.VUE_APP_APIHOST}/ewht/callback`,
            {
              rd_result: this.rd_result
            },
            {
              headers: { Authorization: this.token }
            }
          );
          if (data == "Success") {
            Swal.fire({
              title: "Completed",
              text: "",
              icon: "success",
              showConfirmButton: false,
              timer: 2500
            });
            setTimeout(() => {
              this.openSandboxRD(this.rd_result);
            }, 3000);
          }
        } catch (error) {
          console.log(error.message);
        }
      }
    },
    openSandboxRD(rd_result) {
      let pvno = [];
      if (rd_result.length > 0) {
        for (let index = 0; index < rd_result.length; index++) {
          const element = rd_result[index];

          if (
            element &&
            element.process == "validated" &&
            element.status == "success"
          ) {
            this.paymentno.push(element.transaction_ref);
            this.data_sandboxrd.push(this.rdref);
          }
        }
        console.log("data_sandboxrd", this.data_sandboxrd);

        if (this.data_ewht.length == this.data_sandboxrd.length) {
          // Case all completed
          close();
          let routeData = this.$router.resolve({
            name: "sandboxrd",
            query: { data: this.data_sandboxrd }
          });
          window.open(routeData.href, "_blank");
        } else {
          console.log("length: ", this.data_sandboxrd.length);
          if (this.data_sandboxrd.length > 0) {
            // Case completed and Rejected
            let routeData = this.$router.resolve({
              name: "sandboxrd",
              query: { data: this.data_sandboxrd }
            });
            window.open(routeData.href, "_blank");

            for (let i = 0; i < this.data_ewht.length; i++) {
              const dt1 = this.data_ewht[i];

              for (let j = 0; j < this.paymentno.length; j++) {
                const sb = this.paymentno[j];

                if (dt1.payment_no !== sb) {
                  pvno.push(dt1.order_id);
                }
              }
            }
            console.log("pvno", pvno);
          } else if (this.data_sandboxrd.length == 0) {
            // Case all Rejected
            for (let i = 0; i < this.data_ewht.length; i++) {
              const dt2 = this.data_ewht[i];
              if (dt2) {
                pvno.push(dt2.order_id);
              }
            }
            console.log("pvno", pvno);
          }

          Swal.fire({
            html:
              "กรุณาไปกด Resend ที่เมนูประวัติการนำส่งภาษี<br\>หมายเลขรายการจ่ายเงิน: " +
              pvno,
            icon: "success"
          }).then(result => {
            Swal.fire({
              html:
                "หลังจากทำการ Resend เรียบร้อยแล้ว<br\>กรุณารีเฟรชหน้านี้อีกครั้ง"
            });
          });
        }
      }
    }
  },
  created() {
    this.handleView();

    if (this.$route.query) {
      if (typeof this.$route.query.data == "string") {
        let _data = {
          payment_no: this.$route.query.data
        };
        this.data_payment.push(_data);
      } else {
        for (let index = 0; index < this.$route.query.data.length; index++) {
          const element = this.$route.query.data[index];
          if (element) {
            let _data = {
              payment_no: element
            };
            this.data_payment.push(_data);
          }
        }
      }

      this.getEwhtCallback();
    }
  }
};
</script>

<style scoped>
.btn-completed {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #58a144 !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #ecf8ea !important;
}

.btn-rejected {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #d1392b !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #fbe5e4 !important;
}

.btn-submit {
  margin-top: 30px;
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: white !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #58a144 !important;
  font-family: "Sarabun", sans-serif;
}
</style>
